picard.fingerprint

## Class HaplotypeProbabilitiesFromSequence

- java.lang.Object
- - picard.fingerprint.HaplotypeProbabilities
  - - picard.fingerprint.HaplotypeProbabilitiesFromSequence

- Direct Known Subclasses:
    HaplotypeProbabilitiesFromContaminatorSequence

      public class HaplotypeProbabilitiesFromSequence
      extends HaplotypeProbabilities

  Represents the probability of the underlying haplotype given the data. By convention the alleles stored for each SNP are in phase.

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class picard.fingerprint.HaplotypeProbabilities

      `HaplotypeProbabilities.Genotype`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected int` | `obsAllele1`
    `protected int` | `obsAllele2`
    `protected int` | `obsAlleleOther`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `HaplotypeProbabilitiesFromSequence(HaplotypeBlock haplotypeBlock)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `addToProbs(Snp snp, byte base, byte qual)` Adds a base observation with the observed quality to the evidence for this haplotype based on the fact that the SNP is part of the haplotype.
    `double` | `getFractionUnexpectedAlleleObs()`
    `double[]` | `getLikelihoods()` Converts the loglikelihoods into linear-space.
    `double` | `getLodMostProbableGenotype()` Overridden to calculate the LOD from the loglikelihoods instead of the probabilities because it will allow for more accurate calculation before overflowing.
    `double[]` | `getLogLikelihoods()` Since this class uses loglikelihoods natively, we override and return the native variable
    `int` | `getObsAllele1()` Returns the number of bases/reads that support the first allele.
    `int` | `getObsAllele2()` Returns the number of bases/reads that support the second allele.
    `double[]` | `getPosteriorProbabilities()` Returns the posterior probability of the haplotypes given the evidence (uses the internal prior)
    `Snp` | `getRepresentativeSnp()` Simple returns the SNP from the haplotype that has the lowest genome coordinate.
    `int` | `getTotalObs()` Gets the total number of observations presented at this locus.
    `boolean` | `hasEvidence()` Returns true if evidence has been added, false if the probabilities are just the priors.
    `void` | `merge(HaplotypeProbabilities other)` Merges information from another haplotype probabilities object for the same haplotype into this object.
    `void` | `setLogLikelihoods(double[] ll)`

    - ### Methods inherited from class picard.fingerprint.HaplotypeProbabilities

      `getHaplotype, getMostLikelyGenotype, getMostLikelyHaplotype, getPriorProbablities, scaledEvidenceProbabilityUsingGenotypeFrequencies, shiftedLogEvidenceProbability, shiftedLogEvidenceProbabilityGivenOtherEvidence, shiftedLogEvidenceProbabilityUsingGenotypeFrequencies`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### obsAllele1

          protected int obsAllele1

    - #### obsAllele2

          protected int obsAllele2

    - #### obsAlleleOther

          protected int obsAlleleOther

  - ### Constructor Detail

    - #### HaplotypeProbabilitiesFromSequence

          public HaplotypeProbabilitiesFromSequence(HaplotypeBlock haplotypeBlock)

  - ### Method Detail

    - #### hasEvidence

          public boolean hasEvidence()

      Description copied from class: `HaplotypeProbabilities`
      Returns true if evidence has been added, false if the probabilities are just the priors.

    - #### addToProbs

          public void addToProbs(Snp snp,
                                 byte base,
                                 byte qual)

      Adds a base observation with the observed quality to the evidence for this haplotype based on the fact that the SNP is part of the haplotype.
      Parameters:
        `snp` - The snp in the HaplotypeBlock to which evidence is being added
        `base` - the base observed
        `qual` - the quality of the observed base

    - #### merge

          public void merge(HaplotypeProbabilities other)

      Merges information from another haplotype probabilities object for the same haplotype into this object. Useful for when probabilities need to be merged to levels higher than the read group, e.g. the sample or individual.
      Parameters:
        `other` - Another haplotype probabilities object to merge in

    - #### getObsAllele1

          public int getObsAllele1()

      Returns the number of bases/reads that support the first allele.
      Overrides:
        `getObsAllele1` in class `HaplotypeProbabilities`
      Returns:
        int

    - #### getObsAllele2

          public int getObsAllele2()

      Returns the number of bases/reads that support the second allele.
      Overrides:
        `getObsAllele2` in class `HaplotypeProbabilities`
      Returns:
        int

    - #### getTotalObs

          public int getTotalObs()

      Gets the total number of observations presented at this locus.
      Overrides:
        `getTotalObs` in class `HaplotypeProbabilities`
      Returns:
        int

    - #### getFractionUnexpectedAlleleObs

          public double getFractionUnexpectedAlleleObs()

    - #### getRepresentativeSnp

          public Snp getRepresentativeSnp()

      Simple returns the SNP from the haplotype that has the lowest genome coordinate.
      Specified by:
        `getRepresentativeSnp` in class `HaplotypeProbabilities`

    - #### getPosteriorProbabilities

          public double[] getPosteriorProbabilities()

      Returns the posterior probability of the haplotypes given the evidence (uses the internal prior)
      Overrides:
        `getPosteriorProbabilities` in class `HaplotypeProbabilities`

    - #### getLikelihoods

          public double[] getLikelihoods()

      Converts the loglikelihoods into linear-space.
      Specified by:
        `getLikelihoods` in class `HaplotypeProbabilities`

    - #### getLogLikelihoods

          public double[] getLogLikelihoods()

      Since this class uses loglikelihoods natively, we override and return the native variable
      Overrides:
        `getLogLikelihoods` in class `HaplotypeProbabilities`

    - #### setLogLikelihoods

          public void setLogLikelihoods(double[] ll)

    - #### getLodMostProbableGenotype

          public double getLodMostProbableGenotype()

      Overridden to calculate the LOD from the loglikelihoods instead of the probabilities because it will allow for more accurate calculation before overflowing.
      Overrides:
        `getLodMostProbableGenotype` in class `HaplotypeProbabilities`